function [Final_Beats] = BeatDetection(recordName, signal, ecg_ind, bp_ind, Fs)

annName='qrs';

if isempty(ecg_ind)
    ecg_ind=1;
end

ecg = signal(: , ecg_ind);

N=[];
N0 = [];
threshold = [];
gqrs(recordName,N,N0,ecg_ind(1),threshold,annName);

[sample_number] = rdann(recordName,'qrs');
Final_Beats = sample_number;


if (~isempty(bp_ind))
    
    BP1 = signal(: , bp_ind(1));
    BP1 = High_energy_artifacts_removal(BP1 , Fs);
    BP1 = (BP1 - mean (BP1)) ./ max (BP1);
    
    [~, D2_2, D3_2, D4_2, D5_2] = findDetails(BP1);
    B=D2_2+D3_2+D4_2+D5_2;
    Py2=(B.^2)';
    delta_t = round(Fs/5);
    R_Py2=findbeats(Py2,Fs,3);
    R_Py2=R_Py2-delta_t;
    
    if ~isempty(R_Py2)
        if R_Py2(1)<1
            R_Py2(1)=1;
        end
    end
    %     wabp(recordName);
    %     [sample_number_BP] = rdann(recordName,'wabp');
    
    sample_number_BP_sanchrone=R_Py2;
    
    Duration=length(ecg)/Fs;
    Ratio1=length(sample_number)/Duration;
    Ratio2=length(sample_number_BP_sanchrone)/Duration;
    
    
    if Ratio1>0.8 && Ratio1<2
        if Ratio2>0.8 && Ratio2<2
            CASE=1;
        else
            CASE=2;
        end
    else
        if Ratio2>0.8 && Ratio2<1.9
            CASE=3;
        else
            CASE=1;
        end
    end
    
    
    if CASE==1
        overlap=round(0.05*Fs);
        Final=[];
        gam=5*Fs;
        n=0;
        min_beats=3;
        for i=0:gam:length(ecg)
            
            if i==0     %% ba in a va b hich overlapi mojod nist hata yek sample!!!
                a=i+1;   %% ===>a=i+1+overlap;b=i+gam+overlap;
                b=i+gam+overlap;
            else
                a=i+1-overlap;b=i+gam+overlap;
            end
            
            if i==length(ecg)
                break
            end
            
            temp1=[];temp2=[];
            n=n+1;
            %     a=i+1+c;b=i+gam+c;
            
            for j=1:length(sample_number)
                if sample_number(j)>=a && sample_number(j)<=b
                    temp1=[temp1;sample_number(j)];
                end
                if sample_number(j)>b
                    break
                end
            end
            
            for j=1:length(sample_number_BP_sanchrone)
                if sample_number_BP_sanchrone(j)>=a && sample_number_BP_sanchrone(j)<=b
                    temp2=[temp2;sample_number_BP_sanchrone(j)];
                end
                if sample_number_BP_sanchrone(j)>b
                    break
                end
            end
            temp1x=diff(temp1);
            temp2x=diff(temp2);
            
            if isempty(temp1x) || length(temp1x)<min_beats
                aa=1000;
            else
                aa=var(temp1x);
            end
            if isempty(temp2x) || length(temp2x)<min_beats
                bb=2000;
            else
                bb= var(temp2x);
            end
            
            [~,mj]=min([aa bb]);
            
            if mj==1
                Final=[Final;temp1];
            else
                Final=[Final;temp2];
            end
            
        end
        ECG=ecg;
        % For first & last Beat
        if abs(sample_number(1)-Final(1)) >  0.7*Fs
            Final=[sample_number(1);Final];
        end
        
        if abs(sample_number(end)-Final(end)) >  0.7*Fs
            Final=[Final;sample_number(end)];
        end
        
        initial=Final;
        [Final_Beats0 , temp2]=prediction(initial,sample_number);
        initial=Final_Beats0;
        [Final_Beats] = refine (ECG,initial,Fs);
        
        %         wrann(recordName,annName,Final_Beats,[],[],[],[]);
    end
    
    if CASE==3
        %         wrann(recordName,annName,sample_number_BP_sanchrone,[],[],[],[]);
        Final_Beats=sample_number_BP_sanchrone;
    end
    
    
end

end